package reichert._02_bildbearbeitung;

import processing.core.PApplet;
import processing.core.PImage;

public class AufgabeBildbearbeitungHalbieren extends PApplet {

	private static final long serialVersionUID = 1L;

	int ABSTAND = 10;

	PImage original;
	PImage bearbeitet;

	public void setup() {
		original = loadImage("flickr photos mike 6083251958.jpg");
		original.loadPixels();

		bearbeitet = new PImage(original.width / 2, original.height / 2);
		bearbeitet.loadPixels();

		for (int bearbeitetY = 0; bearbeitetY < bearbeitet.height; bearbeitetY++) {
			for (int bearbeitetX = 0; bearbeitetX < bearbeitet.width; bearbeitetX++) {
				int originalX = bearbeitetX * 2;
				int originalY = bearbeitetY * 2;
				int originalFarbe = getColor(original, originalX, originalY);

				setColor(bearbeitet, bearbeitetX, bearbeitetY, originalFarbe);
			}
		}
		bearbeitet.updatePixels();

		size(ABSTAND + original.width + ABSTAND + bearbeitet.width + ABSTAND, ABSTAND + original.height + ABSTAND);
	}

	int getColor(PImage image, int x, int y) {
		return image.pixels[y * image.width + x];
	}

	void setColor(PImage image, int x, int y, int color) {
		image.pixels[y * image.width + x] = color;
	}

	public void draw() {
		background(255, 255, 255);
		image(original, ABSTAND, ABSTAND, original.width, original.height);
		image(bearbeitet, ABSTAND + original.width + ABSTAND, ABSTAND, bearbeitet.width, bearbeitet.height);

	}

}
