package reichert._01_koordinaten_farben_formen;

import processing.core.PApplet;

public class AufgabeSpringBall extends PApplet {

	private static final long serialVersionUID = 1L;

	float x = 0;
	float y = 100;
	float vx = 3; // Geschwindigkeit in X-Richtung
	float vy = 3; // Geschwindigkeit in Y-Richtung

	public void setup() {
		size(400, 300);
		strokeWeight(4);
		smooth();
		frameRate(90);
	}

	public void draw() {
		stroke(255, 255, 255);
		fill(255, 255, 255, 50);
		rect(0, 0, width, height);

		stroke(200, 50, 50);
		fill(150, 200, 100);
		ellipse(x, y, 30, 30);

		x = x + vx;
		if ((x < 0) || (x > width)) {
			vx = -vx;
		}

		y = y + vy;
		if ((y < 0) || (y > height)) {
			vy = -vy;
		}
	}

}
